'''
For add_game.py:
	it can only be used in games/ sub folder. default arguments for connecting the database has been written into it, which can be easily changed if rebased.
	differences between -gn and -gp: -gn is the name actually showed in the website's menu, whilst -gp is the folder name of the game: in this case, it is preferable that -gp does not contain any spaces.

For packed code: it must be firstly put into a folder then be compressed into a zip file with the same name of the folder.

'''
import MySQLdb
# import mysql.connector as MySQLdb
import argparse
import zipfile
import os.path
import contextlib

def unzip(source_filename, dest_dir):
    with contextlib.closing(zipfile.ZipFile(source_filename)) as zf:
        zf.extractall("./")
        # for member in zf.infolist():
        #     # Path traversal defense copied from
        #     # http://hg.python.org/cpython/file/tip/Lib/http/server.py#l789
        #     words = member.filename.split('/')
        #     path = dest_dir
        #     for word in words[:-1]:
        #         while True:
        #             drive, word = os.path.splitdrive(word)
        #             head, word = os.path.split(word)
        #             if not drive:
        #                 break
        #         if word in (os.curdir, os.pardir, ''):
        #             continue
        #         path = os.path.join(path, word)
        #     zf.extract(member, path)
        #     os.chmod(path, 0o755)
        os.system("chmod -R 755 "+dest_dir)

if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    parser.add_argument('-n', type=str, default='warehouse.cims.nyu.edu', help="hostname of the MySQL server")
    parser.add_argument('-d', type=str, default='by653_adba2', help="name of the database")
    parser.add_argument('-u', type=str, default='by653', help="id of the database admin")
    parser.add_argument('-p', type=str, default='adba2', help="passwd of the database admin")
    parser.add_argument('-gn', type=str, help="name of the game")
    parser.add_argument('-gp', type=str, help="folder name of the game")

    args = parser.parse_args()
    assert args.gn is not None and args.gp is not None
    unzip(args.gp+".zip", args.gp)

    db = MySQLdb.connect(host=args.n, user=args.u, passwd=args.p, db=args.d)
    try:
	db.cursor().execute("INSERT INTO `game` (`name`, `dir`) VALUES (%s, %s);", (args.gn, "games/"+args.gp+"/"))
    except MySQLdb.Error, e:
        try:
            print "MySQL Error [%d]: %s" % (e.args[0], e.args[1])
        except IndexError:
            print "MySQL Error %s" % str(e)
    db.close()
